
//  T7.9_Eratosten bitset.cpp
                           
// Using a bitset to demonstrate the Sieve of Eratosthenes.
// Program is with modifications

#include <iostream>
#include <iomanip>
#include <bitset>          // bitset class definition
#include <cmath>           // sqrt prototype

using namespace std;

int main()
{
   cout << "\n\t Program with using a bitset to demonstrate the Sieve of Eratosthenes.\n";
   system("mode 200");     // for full screen

   const int size = 1024;  // size of bitset
   int value;
   bitset< size > sieve;   // create bitset with size, every bit is 0

   sieve.flip();           // flips all bits in sieve

   // perform Sieve of Eratosthenes
   int finalBit = sqrt( sieve.size() ) + 1;

   for ( int i = 2; i < finalBit; ++i ) 

      if ( sieve.test( i ) )   // returns true if bit i is on

         for ( int j = 2 * i; j < size; j += i ) 
            sieve.reset( j );  // sets bit j of sieve in "off"

   cout << "The prime numbers in the range 1 to 1023 are:\n";

   // display prime numbers in range 1-1023
   for ( int k = 1, counter = 0; k < size; ++k )

      if ( sieve.test( k ) ) {
         cout << setw( 5 ) << k;

         if ( ++counter % 18 == 0 ) 
            cout << '\n';

      } // end outer if          
   
   cout << endl;

   // get value from user to determine whether value is prime
   cout << "\nEnter a value from 1 to 1023 (-1 to end): ";
   cin >> value;

   while ( value != -1 ) {

      if ( sieve[ value ] )
         cout << value << " is a prime number\n";
      else
         cout << value << " is not a prime number\n";
      
      cout << "\nEnter a value from 1 to 1023 (-1 to end): ";
      cin >> value;

   } // end while

   cout << endl;

   system("pause");

   return 0;

} // end main




